/* O'reilly says this -- but this describes things which
 * all get passed in 32bit wide chunks.
 typedef struct {
  INT16 x, y;
  CARD16 width, height, border_width;
  Window sibling;
  BYTE stack_mode;
  BYTE pad;
} xConfigureValue;
*/

typedef struct {
  INT32 x, y;
  CARD32 width, height;
} xConfigureValue;

#define XWD_FILE_VERSION 7

typedef struct _xwd_file_header {
	CARD32 header_size;	  /* Size of the entire file header (bytes). */
	CARD32 file_version;	  /* XWD_FILE_VERSION */
	CARD32 pixmap_format;	  /* Pixmap format */
	CARD32 pixmap_depth;	  /* Pixmap depth */
	CARD32 pixmap_width;	  /* Pixmap width */
	CARD32 pixmap_height;	  /* Pixmap height */
	CARD32 xoffset;           /* Bitmap x offset */
	CARD32 byte_order;        /* MSBFirst, LSBFirst */
	CARD32 bitmap_unit;       /* Bitmap unit */
	CARD32 bitmap_bit_order;  /* MSBFirst, LSBFirst */
	CARD32 bitmap_pad;	  /* Bitmap scanline pad */
	CARD32 bits_per_pixel;	  /* Bits per pixel */
	CARD32 bytes_per_line;	  /* Bytes per scanline */
	CARD32 visual_class;	  /* Class of colormap */
	CARD32 red_mask;	  /* Z red mask */
	CARD32 green_mask;	  /* Z green mask */
	CARD32 blue_mask;	  /* Z blue mask */
	CARD32 bits_per_rgb;	  /* Log base 2 of distinct color values */
	CARD32 colormap_entries;  /* Number of entries in colormap */
	CARD32 ncolors;		  /* Number of Color structures */
	CARD32 window_width;	  /* Window width */
	CARD32 window_height;	  /* Window height */
	INT32 window_x;		  /* Window upper left X coordinate */
	INT32 window_y;		  /* Window upper left Y coordinate */
	CARD32 window_bdrwidth;	  /* Window border width */
} XWDFileHeader;

#define GCFunction              0x00000001
#define GCPlaneMask             0x00000002
#define GCForeground            0x00000004
#define GCBackground            0x00000008
#define GCLineWidth             0x00000010
#define GCLineStyle             0x00000020
#define GCCapStyle              0x00000040
#define GCJoinStyle		0x00000080
#define GCFillStyle		0x00000100
#define GCFillRule		0x00000200
#define GCTile			0x00000400
#define GCStipple		0x00000800
#define GCTileStipXOrigin	0x00001000
#define GCTileStipYOrigin	0x00002000
#define GCFont 			0x00004000
#define GCSubwindowMode		0x00008000
#define GCGraphicsExposures     0x00010000
#define GCClipXOrigin		0x00020000
#define GCClipYOrigin		0x00040000
#define GCClipMask		0x00080000
#define GCDashOffset		0x00100000
#define GCDashList		0x00200000
#define GCArcMode		0x00400000

#define XYBitmap		0	/* depth 1, XYFormat */
#define XYPixmap		1	/* depth == drawable depth */
#define ZPixmap			2	/* depth == drawable depth */
