#!perl
open(COOKED,"<Xproto.cooked") || die "couldn't open Xproto.cooked: $@";



while (<COOKED>) {
    if(/PACK (\w+) ([\w\d]+)/) {
	$xpackof{$1} = $2;
	next;
    }

    if(/TYPE (\w+) (\d+) (\w+)/) {
	# simple typedef
	$xtypeof{$1} = $3;
	$xsizeof{$1} = $2;
	next;
    }
    if(/TYPE (\w+) (\d+) :(.*)/) {
	# struct
	$xtypeof{$1} = $3;
	$xsizeof{$1} = $2;
	next;
    }
    if(/DEF (\w+) (\d+)/) {
	$defines{$1} = $2;
	if(/^DEF X\_(\w+) (\d+)/) {
	    $requests[$2] = $1;
	}
	next;
    }
    print;
}


##  local(@output) = unpack($xpackof{"xConnSetupPrefix"},$reply);
##  $success = &xindexof("xConnSetupPrefix","success",@output);

sub xindexof { # type, tag, @fields
    local($typ,$tag,@fields) = @_;
    local($xele);
    local($ind) = 0;

    for (split(/\:/,$xtypeof{$typ})) {
	m/(\w+) (\w+)/;
	last if($2 eq $tag);
	$ind++;
    }
    $fields[$ind];
}

# We now have:
# given $type (ie xListFontsReq or xListFontsReply)
# $xtypeof{$type}    ":" seperated list of struct elements
# $xsizeof{$type}    number of bits in struct
# $xpackof{$type}    pack() string for struct
# $defines{$name}    anything #define'd  (ie. X_ListFonts == 49)
# $requests[$num]    name of this request (ie. 49 == ListFonts)

sub mkport {
  local($saddr,$port,*FD) = @_;
  
  local($sockaddr,$sin);
  
  $sockaddr = 'S n a4 x8';
  $sin = pack($sockaddr, 2, $port, $saddr);

  socket(FD, 2, 1, 0) || return "socket:$!";

  connect(FD, $sin) || return "connect:$!";

  select(FD); $| = 1; select(STDOUT); $| = 1;
  return "OK";
}

sub x_open_display {
  local($displayname) = @_;
#  local(XFD);
  local($reply);
  
  ($node,$off)=split(':',$displayname);
  ($name, $aliases, $type, $len, $thisaddr) = gethostbyname($node);

# network byte order is MSB first
# byte "B" for MSB first, then CARD16 major, CARD16 minor,
#  STRING8 auth prot name, STRING8 auth prot data
  $status = &mkport($thisaddr,6000+$off,XFD);
  if($status ne "OK") { return $status; }
  
  print XFD pack($xpackof{"xConnClientPrefix"},
		 unpack("S","lB")&255, 0,
		 11, 0,
		 0, 0);

  read(XFD,$reply,1024) || return "read:$!";

  local(@output) = unpack($xpackof{"xConnSetupPrefix"},$reply);
  $success = &xindexof("xConnSetupPrefix","success",@output);
		 
  if($success == 0) {
      print "Proto Major: ",
      &xindexof("xConnSetupPrefix","majorVersion",@output),
      " Proto Minor: ",
      &xindexof("xConnSetupPrefix","minorVersion",@output), "\n";
      $rlen = &xindexof("xConnSetupPrefix","lengthReason",@output);
      $xlen = $xsizeof{"xConnSetupPrefix"}/8;
      print "reason len: $rlen\n";
      ($reason) = unpack("x$xlen a$rlen",$reply);
      return "open failed: $reason";
  } else {
      $xlen = $xsizeof{"xConnSetupPrefix"}/8;
      @output = unpack("x$xlen ".$xpackof{"xConnSetup"}, $reply);
      $xlen += $xsizeof{"xConnSetup"}/8;
      $vlen = &xindexof("xConnSetup","nbytesVendor",@output);
      ($vendor) = unpack("x$xlen a$vlen",$reply);
      print "Vendor: $vendor\n";
      # ignore the rest for now...
      return "OK";
  }      
}

sub x_beep {
  local($percentage) = @_;
  print XFD pack($xpackof{"xBellReq"},$defines{"X_Bell"},$percentage,1);
  "OK";
}

sub x_configure {
    local($wind,$mask,$x,$y,$width,$height,$bord,$sib,$mode)=@_;
    local($pkt,$val,$lll);

    print "using: ",
    "xcv :", $xpackof{"xConfigureValue"},
    "xcwr:", $xpackof{"xConfigureWindowReq"},
    "req :", $defines{"X_ConfigureWindow"}, "\n";

    $val = pack($xpackof{"xConfigureValue"},
		$x, $y, $width, $height);
    $lll = (length($val)+($xsizeof{"xConfigureWindowReq"}/8));
    $pkt = pack($xpackof{"xConfigureWindowReq"},
		$defines{"X_ConfigureWindow"},0,
		$lll/4,
		$wind,$mask,0);
    $pkt .= $val;
    print "len: $lll\n";
    printf ("%02x " x length($pkt), unpack("C$lll",$pkt));
    print "\n";
    print XFD $pkt;
    "OK";
}

print &x_open_display($ENV{"DISPLAY"}),"\n";

# print &x_beep(0),"\n";

print &x_configure($ENV{"WINDOWID"},0xf,400,20,499,654,0,0,0),"\n";

close XFD;
